# Contact form example

<examples-form-contact />

<docs-code-snippet>

```html
<template>
  <form
    class="grid grid-cols-6 gap-8"
    novalidate="true"
    @submit.prevent="submit"
    @reset.prevent="reset"
  >
    <ui-input
      v-model="formData.firstName"
      class="col-span-3"
      label="First Name"
      :errors="errorMessages.input"
      required
      :touched="touched.firstName"
      @blur="touch('firstName' as keyof typeof ref)"
    />
    <ui-input
      v-model="formData.lastName"
      class="col-span-3"
      label="Last Name"
      :errors="errorMessages.input"
      required
      :touched="touched.lastName"
      @blur="touch('lastName' as keyof typeof ref)"
    />
    <ui-input
      v-model="formData.email"
      class="col-span-6"
      label="Email"
      type="email"
      :errors="errorMessages.input"
      required
      :touched="touched.email"
      @blur="touch('email' as keyof typeof ref)"
    >
      <template #iconLeft>
        <at-symbol-icon />
      </template>
    </ui-input>
    <ui-select
      v-model="formData.subject"
      class="col-span-6"
      label="Subject"
      :errors="errorMessages.select"
      required
      :touched="touched.subject"
      @blur="touch('subject' as keyof typeof ref)"
    >
      <template #icon>
        <tag-icon />
      </template>
      <option value="account">Account</option>
      <option value="order">Order</option>
      <option value="other">Other</option>
    </ui-select>
    <ui-textarea
      v-model="formData.message"
      class="col-span-6"
      label="Your Message"
      rows="4"
      :errors="errorMessages.input"
      required
      :touched="touched.message"
      @blur="touch('message' as keyof typeof ref)"
    />
    <ui-radio-group
      v-model="formData.marketing"
      name="marketing"
      label="May we use your email address for marketing purposes?"
      :options="[
        { id: true, label: 'yes' },
        { id: false, label: 'no' },
      ]"
      class="col-span-6"
      :errors="errorMessages.select"
      required
      :touched="touched.marketing"
      @blur="touch('marketing' as keyof typeof ref)"
    />
    <ui-button class="col-span-3 sm:col-span-2" type="reset" danger light>
      <template #iconLeft>
        <trash-icon />
      </template>
      Clear
    </ui-button>
    <ui-button
      class="col-span-3 col-start-4 sm:col-span-2 sm:col-start-5"
      type="submit"
    >
      Submit
      <template #iconLeft>
        <check-icon />
      </template>
    </ui-button>
  </form>
</template>

<script lang="ts" setup>
  import { ref } from 'vue'
  import {
    AtSymbolIcon,
    CheckIcon,
    TagIcon,
    TrashIcon,
  } from '@heroicons/vue/20/solid'

  const formSchema = {
    firstName: '',
    lastName: '',
    email: '',
    marketing: undefined,
    subject: undefined,
    message: '',
  }

  const errorMessages = {
    input: 'Please fill in this field!',
    select: 'Please select one of the options!',
  }

  const formData = ref({ ...formSchema })

  const touched = ref(
    Object.fromEntries(Object.keys(formSchema).map((key) => [key, false])),
  )

  const reset = () => (formData.value = { ...formSchema })

  const submit = () => {
    const invalidEntries = Object.entries(formData.value).filter(([, value]) =>
      [undefined, null, ''].includes(value),
    )

    if (invalidEntries.length) {
      for (const [field] of invalidEntries) {
        touch(field as keyof typeof ref)
      }
    } else {
      alert(
        'The following information has been submitted:\n\n' +
          JSON.stringify(formData.value, null, 4),
      )
    }
  }

  const touch = (field: keyof typeof ref) => {
    touched.value[field] = [undefined, null, ''].includes(formData.value[field])
  }
</script>
```

</docs-code-snippet>
